/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const M=require("./interfaces/common.js"),e=require("./json-classes.js"),f={wrapper:{main:e.buttonPrefix,size:{small:`${e.buttonPrefix}-${e.sizeMap.small}`,medium:`${e.buttonPrefix}-${e.sizeMap.medium}`,large:`${e.buttonPrefix}-${e.sizeMap.large}`},fillMode:{solid:`${e.buttonPrefix}-${e.fillModeMap.solid}`,outline:`${e.buttonPrefix}-${e.fillModeMap.outline}`,flat:`${e.buttonPrefix}-${e.fillModeMap.flat}`,link:`${e.buttonPrefix}-${e.fillModeMap.link}`,clear:`${e.buttonPrefix}-${e.fillModeMap.clear}`},themeColor:{base:{fillMode:{solid:`${e.buttonPrefix}-${e.fillModeMap.solid}-${e.themeColorMap.base}`,outline:`${e.buttonPrefix}-${e.fillModeMap.outline}-${e.themeColorMap.base}`,flat:`${e.buttonPrefix}-${e.fillModeMap.flat}-${e.themeColorMap.base}`,link:`${e.buttonPrefix}-${e.fillModeMap.link}-${e.themeColorMap.base}`,clear:`${e.buttonPrefix}-${e.fillModeMap.clear}-${e.themeColorMap.base}`}},primary:{fillMode:{solid:`${e.buttonPrefix}-${e.fillModeMap.solid}-${e.themeColorMap.primary}`,outline:`${e.buttonPrefix}-${e.fillModeMap.outline}-${e.themeColorMap.primary}`,flat:`${e.buttonPrefix}-${e.fillModeMap.flat}-${e.themeColorMap.primary}`,link:`${e.buttonPrefix}-${e.fillModeMap.link}-${e.themeColorMap.primary}`,clear:`${e.buttonPrefix}-${e.fillModeMap.clear}-${e.themeColorMap.primary}`}},secondary:{fillMode:{solid:`${e.buttonPrefix}-${e.fillModeMap.solid}-${e.themeColorMap.secondary}`,outline:`${e.buttonPrefix}-${e.fillModeMap.outline}-${e.themeColorMap.secondary}`,flat:`${e.buttonPrefix}-${e.fillModeMap.flat}-${e.themeColorMap.secondary}`,link:`${e.buttonPrefix}-${e.fillModeMap.link}-${e.themeColorMap.secondary}`,clear:`${e.buttonPrefix}-${e.fillModeMap.clear}-${e.themeColorMap.secondary}`}},tertiary:{fillMode:{solid:`${e.buttonPrefix}-${e.fillModeMap.solid}-${e.themeColorMap.tertiary}`,outline:`${e.buttonPrefix}-${e.fillModeMap.outline}-${e.themeColorMap.tertiary}`,flat:`${e.buttonPrefix}-${e.fillModeMap.flat}-${e.themeColorMap.tertiary}`,link:`${e.buttonPrefix}-${e.fillModeMap.link}-${e.themeColorMap.tertiary}`,clear:`${e.buttonPrefix}-${e.fillModeMap.clear}-${e.themeColorMap.tertiary}`}},info:{fillMode:{solid:`${e.buttonPrefix}-${e.fillModeMap.solid}-${e.themeColorMap.info}`,outline:`${e.buttonPrefix}-${e.fillModeMap.outline}-${e.themeColorMap.info}`,flat:`${e.buttonPrefix}-${e.fillModeMap.flat}-${e.themeColorMap.info}`,link:`${e.buttonPrefix}-${e.fillModeMap.link}-${e.themeColorMap.info}`,clear:`${e.buttonPrefix}-${e.fillModeMap.clear}-${e.themeColorMap.info}`}},success:{fillMode:{solid:`${e.buttonPrefix}-${e.fillModeMap.solid}-${e.themeColorMap.success}`,outline:`${e.buttonPrefix}-${e.fillModeMap.outline}-${e.themeColorMap.success}`,flat:`${e.buttonPrefix}-${e.fillModeMap.flat}-${e.themeColorMap.success}`,link:`${e.buttonPrefix}-${e.fillModeMap.link}-${e.themeColorMap.success}`,clear:`${e.buttonPrefix}-${e.fillModeMap.clear}-${e.themeColorMap.success}`}},warning:{fillMode:{solid:`${e.buttonPrefix}-${e.fillModeMap.solid}-${e.themeColorMap.warning}`,outline:`${e.buttonPrefix}-${e.fillModeMap.outline}-${e.themeColorMap.warning}`,flat:`${e.buttonPrefix}-${e.fillModeMap.flat}-${e.themeColorMap.warning}`,link:`${e.buttonPrefix}-${e.fillModeMap.link}-${e.themeColorMap.warning}`,clear:`${e.buttonPrefix}-${e.fillModeMap.clear}-${e.themeColorMap.warning}`}},error:{fillMode:{solid:`${e.buttonPrefix}-${e.fillModeMap.solid}-${e.themeColorMap.error}`,outline:`${e.buttonPrefix}-${e.fillModeMap.outline}-${e.themeColorMap.error}`,flat:`${e.buttonPrefix}-${e.fillModeMap.flat}-${e.themeColorMap.error}`,link:`${e.buttonPrefix}-${e.fillModeMap.link}-${e.themeColorMap.error}`,clear:`${e.buttonPrefix}-${e.fillModeMap.clear}-${e.themeColorMap.error}`}},dark:{fillMode:{solid:`${e.buttonPrefix}-${e.fillModeMap.solid}-${e.themeColorMap.dark}`,outline:`${e.buttonPrefix}-${e.fillModeMap.outline}-${e.themeColorMap.dark}`,flat:`${e.buttonPrefix}-${e.fillModeMap.flat}-${e.themeColorMap.dark}`,link:`${e.buttonPrefix}-${e.fillModeMap.link}-${e.themeColorMap.dark}`,clear:`${e.buttonPrefix}-${e.fillModeMap.clear}-${e.themeColorMap.dark}`}},light:{fillMode:{solid:`${e.buttonPrefix}-${e.fillModeMap.solid}-${e.themeColorMap.light}`,outline:`${e.buttonPrefix}-${e.fillModeMap.outline}-${e.themeColorMap.light}`,flat:`${e.buttonPrefix}-${e.fillModeMap.flat}-${e.themeColorMap.light}`,link:`${e.buttonPrefix}-${e.fillModeMap.link}-${e.themeColorMap.light}`,clear:`${e.buttonPrefix}-${e.fillModeMap.clear}-${e.themeColorMap.light}`}},inverse:{fillMode:{solid:`${e.buttonPrefix}-${e.fillModeMap.solid}-${e.themeColorMap.inverse}`,outline:`${e.buttonPrefix}-${e.fillModeMap.outline}-${e.themeColorMap.inverse}`,flat:`${e.buttonPrefix}-${e.fillModeMap.flat}-${e.themeColorMap.inverse}`,link:`${e.buttonPrefix}-${e.fillModeMap.link}-${e.themeColorMap.inverse}`,clear:`${e.buttonPrefix}-${e.fillModeMap.clear}-${e.themeColorMap.inverse}`}}},rounded:{small:`${e.base.prefix}-${e.base.rounded}-${e.roundedMap.small}`,medium:`${e.base.prefix}-${e.base.rounded}-${e.roundedMap.medium}`,large:`${e.base.prefix}-${e.base.rounded}-${e.roundedMap.large}`},iconButton:`${e.base.prefix}-${e.elements.icon}-${e.elements.button}`,disabled:`${e.base.prefix}-${e.states.disabled}`,selected:`${e.base.prefix}-${e.states.selected}`,isRtl:`${e.base.prefix}-${e.base.rtl}`},text:`${e.buttonPrefix}-${e.elements.text}`,icon:`${e.buttonPrefix}-${e.elements.icon}`},x={wrapper:i=>{const{isRtl:o,selected:r,disabled:l,size:t,fillMode:d,rounded:s,themeColor:b,iconButton:c,c:m=f}=i,a=m.wrapper,n=a.themeColor[b],p=n.fillMode[d];return{[a.main]:!0,[a.size[t]]:a.size[t],[`${e.buttonPrefix}-${t}`]:t&&!a.size[t],[a.fillMode[d]]:a.fillMode[d],[p]:p,[a.rounded[s]]:a.rounded[s],[`${e.base.prefix}-${e.base.rounded}-${s}`]:s&&!a.rounded[s],[a.iconButton]:c,[n.disabled]:l&&n&&n.disabled,[n.selected]:r&&n&&n.selected,[a.disabled]:l,[a.selected]:r,[a.isRtl]:o}},text:i=>{const{c:o=f}=i;return{[o.text]:!0}},icon:i=>{const{c:o=f}=i;return{[o.icon]:!0}}},u={wrapper:{main:`${e.buttonPrefix}-${e.containers.group}`,stretched:`${e.buttonPrefix}-${e.containers.group}-${e.states.stretched}`,disabled:`${e.base.prefix}-${e.states.disabled}`},position:{start:`${e.base.prefix}-${e.containers.group}-${e.directionMap.start}`,end:`${e.base.prefix}-${e.containers.group}-${e.directionMap.end}`}},P={wrapper:i=>{const{stretched:o,disabled:r,c:l=u}=i,t=l.wrapper;return{[t.main]:!0,[t.stretched]:o,[t.disabled]:r}},position:i=>{const{start:o,end:r,c:l=u}=i,t=l.position;return{[t.start]:o,[t.end]:r}}},$={wrapper:{main:`${e.ddbPrefix}-${e.elements.button}`,focus:`${e.base.prefix}-${e.states.focus}`,disabled:`${e.base.prefix}-${e.states.disabled}`},ul:{group:`${e.ddbPrefix}-${e.containers.group}`,size:{small:`${e.ddbPrefix}-${e.containers.group}-${e.sizeMap.small}`,medium:`${e.ddbPrefix}-${e.containers.group}-${e.sizeMap.medium}`,large:`${e.ddbPrefix}-${e.containers.group}-${e.sizeMap.large}`}},li:{item:`${e.base.prefix}-${e.containers.item}`,focus:`${e.base.prefix}-${e.states.focus}`},item:`${e.ddbPrefix}-${e.containers.item}`,link:{main:`${e.base.prefix}-${e.elements.link}`,link:`${e.ddbPrefix}-${e.elements.link}`,selected:`${e.base.prefix}-${e.states.selected}`,disabled:`${e.base.prefix}-${e.states.disabled}`},popup:`${e.ddbPrefix}-${e.containers.popup}`},h={wrapper:i=>{const{focused:o,disabled:r,c:l=$}=i,t=l.wrapper;return{[t.main]:!0,[t.focus]:o,[t.disabled]:r}},ul:i=>{const{size:o,c:r=$}=i,l=r.ul;return{[l.group]:!0,[l.size[o]]:l.size[o],[`${e.ddbPrefix}-${e.containers.group}-${o}`]:o&&!l.size[o]}},li:i=>{const{focused:o,c:r=$}=i,l=r.li;return{[l.item]:!0,[l.focus]:o}},item:M.getClassByName($,"item"),link:i=>{const{selected:o,disabled:r,c:l=$}=i,t=l.link;return{[t.main]:!0,[t.link]:!0,[t.selected]:o,[t.disabled]:r}},popup:M.getClassByName($,"popup")};exports.uButton=x;exports.uButtonGroup=P;exports.uDropDownButton=h;
