/**
 * @license
 *-------------------------------------------------------------------------------------------
 * Copyright © 2025 Progress Software Corporation. All rights reserved.
 * Licensed under commercial license. See LICENSE.md in the package root for more information
 *-------------------------------------------------------------------------------------------
 */
"use strict";Object.defineProperty(exports,Symbol.toStringTag,{value:"Module"});const p=require("./interfaces/common.js"),e=require("./json-classes.js"),l=`${e.base.prefix}-${e.inputs.input}`,C=`${e.base.prefix}-${e.inputs.maskedtextbox}`,u=`${e.base.prefix}-${e.inputs.radio}`,g=`${e.base.prefix}-${e.inputs.textbox}`,f=`${e.base.prefix}-${e.inputs.input}-${e.inputs.prefix}`,m=`${e.base.prefix}-${e.inputs.input}-${e.inputs.suffix}`,b={input:{radio:u,size:{prefix:`${u}-`,small:`${u}-${e.sizeMap.small}`,medium:`${u}-${e.sizeMap.medium}`,large:`${u}-${e.sizeMap.large}`},invalid:`${e.base.prefix}-${e.states.invalid}`,checked:`${e.base.prefix}-${e.states.checked}`},wrap:`${u}-${e.containers.wrap}`,label:`${u}-${e.elements.label}`},h={input:o=>{var n;const{size:t,invalid:r,checked:a,c:d=b}=o,s=d.input;return{[s==null?void 0:s.radio]:!0,[s==null?void 0:s.size[t]]:s==null?void 0:s.size[t],[`${(n=s==null?void 0:s.size)==null?void 0:n.prefix}${t}`]:t&&!(s!=null&&s.size[t]),[s==null?void 0:s.invalid]:r,[s==null?void 0:s.checked]:a}},label:o=>{const{c:t=b}=o;return{[t==null?void 0:t.label]:!0}},wrap:o=>{const{c:t=b}=o;return{[t==null?void 0:t.wrap]:!0}}},x={ul:{main:`${u}-${e.containers.list}`,horizontal:`${e.base.prefix}-${e.containers.list}-${e.states.horizontal}`,vertical:`${e.base.prefix}-${e.containers.list}-${e.states.vertical}`},item:{main:`${u}-${e.containers.list}-${e.containers.item}`,disabled:`${e.base.prefix}-${e.states.disabled}`}},R={ul:o=>{const{horizontal:t,vertical:r,c:a=x}=o,d=a.ul;return{[d==null?void 0:d.main]:!0,[d==null?void 0:d.horizontal]:t,[d==null?void 0:d.vertical]:r}},item:o=>{const{disabled:t,c:r=x}=o,a=r.item;return{[a==null?void 0:a.main]:!0,[a==null?void 0:a.disabled]:t}}},M={wrapper:{main:C,input:l,size:{small:`${l}-${e.sizeMap.small}`,medium:`${l}-${e.sizeMap.medium}`,large:`${l}-${e.sizeMap.large}`},fillMode:{solid:`${l}-${e.fillModeMap.solid}`,outline:`${l}-${e.fillModeMap.outline}`,flat:`${l}-${e.fillModeMap.flat}`},rounded:{small:`${e.base.prefix}-${e.base.rounded}-${e.roundedMap.small}`,medium:`${e.base.prefix}-${e.base.rounded}-${e.roundedMap.medium}`,large:`${e.base.prefix}-${e.base.rounded}-${e.roundedMap.large}`},disabled:`${e.base.prefix}-${e.states.disabled}`,invalid:`${e.base.prefix}-${e.states.invalid}`,isRtl:`${e.base.prefix}-${e.base.rtl}`},inputInner:`${l}-${e.inputs.inner}`},q={wrapper:o=>{const{invalid:t,disabled:r,size:a,fillMode:d,rounded:s,c:n=M}=o,$=n.wrapper;return{[$.main]:!0,[$.input]:!0,[$.size[a]]:$.size[a],[`${l}-${a}`]:!$.size[a],[$.fillMode[d]]:$.fillMode[d],[$.rounded[s]]:$.rounded[s],[`${e.base.prefix}-${e.base.rounded}-${s}`]:s&&!$.rounded[s],[$.disabled]:r,[$.invalid]:t}},inputInner:p.getClassByName(M,"inputInner")},c={wrapper:{main:g,input:l,size:{small:`${l}-${e.sizeMap.small}`,medium:`${l}-${e.sizeMap.medium}`,large:`${l}-${e.sizeMap.large}`},fillMode:{solid:`${l}-${e.fillModeMap.solid}`,outline:`${l}-${e.fillModeMap.outline}`,flat:`${l}-${e.fillModeMap.flat}`},rounded:{small:`${e.base.prefix}-${e.base.rounded}-${e.roundedMap.small}`,medium:`${e.base.prefix}-${e.base.rounded}-${e.roundedMap.medium}`,large:`${e.base.prefix}-${e.base.rounded}-${e.roundedMap.large}`},disabled:`${e.base.prefix}-${e.states.disabled}`,focused:`${e.base.prefix}-${e.states.focus}`,required:`${e.base.prefix}-${e.states.required}`,invalid:`${e.base.prefix}-${e.states.invalid}`,isRtl:`${e.base.prefix}-${e.base.rtl}`},inputInner:`${l}-${e.inputs.inner}`,prefix:{main:f,orientation:{horizontal:`${f}-${e.orientationMap.horizontal}`,vertical:`${f}-${e.orientationMap.vertical}`}},suffix:{main:m,orientation:{horizontal:`${m}-${e.orientationMap.horizontal}`,vertical:`${m}-${e.orientationMap.vertical}`}}},k={wrapper:o=>{const{disabled:t,invalid:r,focused:a,required:d,size:s,fillMode:n,rounded:$,isRtl:v,c:B=c}=o,i=B.wrapper;return{[i==null?void 0:i.main]:!0,[i==null?void 0:i.input]:!0,[i==null?void 0:i.size[s]]:i==null?void 0:i.size[s],[`${l}-${s}`]:s&&!(i!=null&&i.size[s]),[i==null?void 0:i.fillMode[n]]:i==null?void 0:i.fillMode[n],[i==null?void 0:i.rounded[$]]:i==null?void 0:i.rounded[$],[`${e.base.prefix}-${e.base.rounded}-${$}`]:$&&!(i!=null&&i.rounded[$]),[i==null?void 0:i.disabled]:t,[i==null?void 0:i.focused]:a,[i==null?void 0:i.required]:d,[i==null?void 0:i.invalid]:r,[i==null?void 0:i.isRtl]:v}},inputInner:p.getClassByName(c,"inputInner"),prefix:o=>{const{orientation:t,c:r=c}=o,a=r.prefix;return{[a.main]:!0,[a.orientation[t]]:a.orientation[t]}},suffix:o=>{const{orientation:t,c:r=c}=o,a=r.suffix;return{[a==null?void 0:a.main]:!0,[a==null?void 0:a.orientation[t]]:a==null?void 0:a.orientation[t]}}},z={input:{main:`${l} ${l}-${e.sizeMap.medium} ${e.base.prefix}-${e.base.rounded}-${e.roundedMap.medium} ${l}-${e.fillModeMap.solid}`,disabled:`${e.base.prefix}-${e.states.disabled}`,required:`${e.base.prefix}-${e.states.required}`,invalid:`${e.base.prefix}-${e.states.invalid}`,isRtl:`${e.base.prefix}-${e.base.rtl}`},clearButton:`${e.base.prefix}-${e.base.clear}-${e.base.value}`},T={input:o=>{const{disabled:t,invalid:r,required:a,isRtl:d,c:s=z}=o,n=s.input;return{[n==null?void 0:n.main]:!0,[n==null?void 0:n.disabled]:t,[n==null?void 0:n.required]:a,[n==null?void 0:n.invalid]:r,[n==null?void 0:n.isRtl]:d}},clearButton:p.getClassByName(z,"clearButton")};exports.radioButtonClasses=b;exports.radioGroupClasses=x;exports.uInput=T;exports.uMaskedTextBox=q;exports.uRadioButton=h;exports.uRadioGroup=R;exports.uTextBox=k;
